now890A(可逆背包)

题目链接

https://ac.nowcoder.com/acm/contest/890/A

题意

给定 $n$ 张卡牌,将牌打乱后,可以选择抽一张牌,或者结束游戏,如果游戏结束时抽到的牌的数之和如果在 $(a,b]$ 内,则获胜,否则失败。

求在使用最优策略的情况下,获胜的概率

题解

感觉是个不错的题。。

首先考虑牌的顺序的情况,如果当前抽到的数比 $a$ 小,必然还要再抽,如果在区间 $(a,b]$ 中,那就直接结束。所以问题转化为,在前缀和中是否有落在 $(a,b]$ 中,由于前缀和有多个点落在区间中比较难处理,所以求前缀和均在区间 $(a,b]$ 中的排列的个数。。

要使得前缀和不在区间中,要么所有数之和小于等于 $a$ ,要么通过某张牌从 $\le a$ 跨到 $>b$ ,那么可以枚举这张牌,然后问题转化为求前面的牌的排列数。。

这个如果用背包来做的话显然会忽略排列顺序,然而如果在背包中多一维记录牌的个数,那么直接在方案数上手动乘排列数就可以了。。

这样就枚举牌放进背包转移,复杂度 $O(n^4)$ ,不可接受。。

考虑到每次只是挖去一个点形成计数背包,所以可以考虑可逆背包,这样每次挖去物品相当于放进权值为负的物品,然后复杂度降到 $O(n^3)$

至于数值问题和精度问题,由于 $500!$ 在 $long\,double$ 的表示范围内,所以直接用 $long\,double$ 去计算就可以了,预处理阶乘可以降低精度误差。。




代码

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49
50
51
52
53
54
55
56
57
58
59
60
61
62
63
64
65
66
67
68
69
70
71
72
73
74
75
76
77
78
79
80
81
82
83
84
/**
*         ┏┓    ┏┓
*         ┏┛┗━━━━━━━┛┗━━━┓
*         ┃       ┃  
*         ┃   ━    ┃
*         ┃ >   < ┃
*         ┃       ┃
*         ┃... ⌒ ...  ┃
*         ┃ ┃
*         ┗━┓ ┏━┛
*          ┃ ┃ Code is far away from bug with the animal protecting          
*          ┃ ┃ 神兽保佑,代码无bug
*          ┃ ┃           
*          ┃ ┃       
*          ┃ ┃
*          ┃ ┃           
*          ┃ ┗━━━┓
*          ┃ ┣┓
*          ┃ ┏┛
*          ┗┓┓┏━━━━━━━━┳┓┏┛
*           ┃┫┫ ┃┫┫
*           ┗┻┛ ┗┻┛
*/

#include<cstdio>
#include<cstring>
#include<algorithm>
#include<iostream>
#include<queue>
#include<map>
#include<stack>
#include<set>
#include<bitset>
#include<cmath>
#include<assert.h>
#define inc(i,l,r) for(int i=l;i<=r;i++)
#define dec(i,l,r) for(int i=l;i>=r;i--)
#define link(x) for(edge *j=h[x];j;j=j->next)
#define mem(a) memset(a,0,sizeof(a))
#define ll long long
#define eps 1e-8
#define succ(x) (1<<x)
#define lowbit(x) (x&(-x))
#define sqr(x) ((x)*(x))
#define mid (x+y>>1)
#define NM 505
#define nm 128
#define pi 3.1415926535897931
using namespace std;
const ll inf=1e18;
ll read(){
ll x=0,f=1;char ch=getchar();
while(!isdigit(ch)){if(ch=='-')f=-1;ch=getchar();}
while(isdigit(ch))x=x*10+ch-'0',ch=getchar();
return f*x;
}




int n,_a,_b,a[NM],s;
long double d[NM][NM],g[NM][NM],p[NM];
long double ans;

int main(){
n=read();_a=read();_b=read();
p[0]=1;inc(i,1,n)p[i]=p[i-1]*i;
inc(i,1,n)a[i]=read(),s+=a[i];
if(s<=_a)return 0*printf("0\n");
d[0][0]=1;
inc(k,1,n){
dec(i,k,1)inc(j,a[k],_a)d[i][j]+=d[i-1][j-a[k]];
}
inc(k,1,n)if(a[k]>=_b+1-_a){
memcpy(g,d,sizeof(d));
inc(i,1,n){
inc(j,a[k],_a)g[i][j]-=g[i-1][j-a[k]];
}
inc(i,0,n-1)inc(j,max(_b+1-a[k],0),_a)ans+=g[i][j]*p[i]*p[n-i-1];
}
//printf("%lf\n",ans);
ans/=p[n];
printf("%.10lf\n",(double)(1-ans));
return 0;
}